// Datei UebDivModRLJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktionen divRL und modRL in
der Klasse UebDivModRL
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse

public class UebDivModRLJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebDivModRLJut.class);
   } // suite
   // ---------------------------------------------------------------------
   public void test01() {
      assertEquals(+3, UebDivModRL.divRL(+7, +2));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      assertEquals(+1, UebDivModRL.modRL(+7, +2));
   } // test02
   // ---------------------------------------------------------------------
   public void test03() {
      assertEquals(-3, UebDivModRL.divRL(-7, +2));
   } // test03
   // ---------------------------------------------------------------------
   public void test04() {
      assertEquals(-1, UebDivModRL.modRL(-7, +2));
   } // test04
   // ---------------------------------------------------------------------
   public void test05() {
      assertEquals(-3, UebDivModRL.divRL(+7, -2));
   } // test05
   // ---------------------------------------------------------------------
   public void test06() {
      assertEquals(+1, UebDivModRL.modRL(+7, -2));
   } // test06
   // ---------------------------------------------------------------------
   public void test07() {
      assertEquals(+3, UebDivModRL.divRL(-7, -2));
   } // test07
   // ---------------------------------------------------------------------
   public void test08() {
      assertEquals(-1, UebDivModRL.modRL(-7, -2));
   } // test08
   // ---------------------------------------------------------------------
   public void test09() {
      for (int dnd=-10; dnd<=+10; dnd++) {
         // Einen Divisor 0 vermeiden:
         for (int dorP=1, dorN=-1; dorP<=+10; dorP++, dorN--) {
            // Mit positivem Divisor dorP:
            int divP = UebDivModRL.divRL(+dnd, dorP);
            int modP = UebDivModRL.modRL(+dnd, dorP);
            assertEquals(dnd, modP + (dorP*divP));

            // Mit negativem Divisor dorN:
            int divN = UebDivModRL.divRL(+dnd, dorN);
            int modN = UebDivModRL.modRL(+dnd, dorN);
            assertEquals(dnd, modN + (dorN*divN));
         }
      }
   } // test08
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebDivModRLJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebDivModRLJut
