// Datei UebDrehRumALJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktion DrehRumAL in
der Klasse UebDrehRumAL
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse
import java.util.ArrayList;
import java.util.Arrays;

public class UebDrehRumALJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebDrehRumALJut.class);
   } // suite
   // ---------------------------------------------------------------------
   static private boolean istFlacheKopie(ArrayList<Integer> orig,
                                         ArrayList<Integer> kopi)
   {
      // Liefert true, wenn orig und kopie nicht identisch sind, sondern
      // kopi eine flache Kopie von orig ist.

      if (orig == kopi)               return false;
      if (orig.size() != kopi.size()) return false;

      for (int i=0; i<orig.size(); i++) {
         // ist orig.get(i) dasselbe Objekt wie kopi.get(i)?
         if (orig.get(i) != kopi.get(i)) return false;
      }
      return true;
   } // istFlacheKopie
   // ---------------------------------------------------------------------
   Integer a1 = new Integer(1);
   Integer a2 = new Integer(2);
   Integer a3 = new Integer(3);
   Integer a4 = new Integer(4);
   Integer a5 = new Integer(5);
   // ---------------------------------------------------------------------
   public void test01() {
      Integer[] origR = {a1, a2, a3, a4, a5};
      Integer[] sollR = {a5, a4, a3, a2, a1};

      ArrayList<Integer> origL = new ArrayList<Integer>(Arrays.asList(origR));
      ArrayList<Integer> kopiL = new ArrayList<Integer>(Arrays.asList(origR));
      ArrayList<Integer> sollL = new ArrayList<Integer>(Arrays.asList(sollR));

      ArrayList<Integer> istL  = UebDrehRumAL.DrehRumAL(origL);

      assertTrue(origL.equals(kopiL));       // orig muss unveraendert sein
      assertTrue(istFlacheKopie(sollL, istL));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      Integer[] origR = {a1, a2};
      Integer[] sollR = {a2, a1};

      ArrayList<Integer> origL = new ArrayList<Integer>(Arrays.asList(origR));
      ArrayList<Integer> kopiL = new ArrayList<Integer>(Arrays.asList(origR));
      ArrayList<Integer> sollL = new ArrayList<Integer>(Arrays.asList(sollR));

      ArrayList<Integer> istL  = UebDrehRumAL.DrehRumAL(origL);

      assertTrue(origL.equals(kopiL));       // orig muss unveraendert sein
      assertTrue(istFlacheKopie(sollL, istL));
   } // test02
   // ---------------------------------------------------------------------
   public void test03() {
      Integer[] origR = {a1};
      Integer[] sollR = {a1};

      ArrayList<Integer> origL = new ArrayList<Integer>(Arrays.asList(origR));
      ArrayList<Integer> kopiL = new ArrayList<Integer>(Arrays.asList(origR));
      ArrayList<Integer> sollL = new ArrayList<Integer>(Arrays.asList(sollR));

      ArrayList<Integer> istL  = UebDrehRumAL.DrehRumAL(origL);

      assertTrue(origL.equals(kopiL));       // orig muss unveraendert sein
      assertTrue(istFlacheKopie(sollL, istL));
   } // test03
   // ---------------------------------------------------------------------
   public void test04() {
      Integer[] origR = {};
      Integer[] sollR = {};

      ArrayList<Integer> origL = new ArrayList<Integer>(Arrays.asList(origR));
      ArrayList<Integer> kopiL = new ArrayList<Integer>(Arrays.asList(origR));
      ArrayList<Integer> sollL = new ArrayList<Integer>(Arrays.asList(sollR));

      ArrayList<Integer> istL  = UebDrehRumAL.DrehRumAL(origL);

      assertTrue(origL.equals(kopiL));       // orig muss unveraendert sein
      assertTrue(istFlacheKopie(sollL, istL));
   } // test04
   // ---------------------------------------------------------------------
   public void test05() {
      Integer b1 = new Integer(17);
      Integer b2 = new Integer(17);
      Integer b3 = new Integer(17);
      Integer b4 = new Integer(17);
      Integer b5 = new Integer(17);

      Integer[] origR = {b1, b2, b3, b4, b5};
      Integer[] sollR = {b5, b4, b3, b2, b1};

      ArrayList<Integer> origL = new ArrayList<Integer>(Arrays.asList(origR));
      ArrayList<Integer> kopiL = new ArrayList<Integer>(Arrays.asList(origR));
      ArrayList<Integer> sollL = new ArrayList<Integer>(Arrays.asList(sollR));

      ArrayList<Integer> istL  = UebDrehRumAL.DrehRumAL(origL);

      assertTrue(origL.equals(kopiL));       // orig muss unveraendert sein
      assertTrue(istFlacheKopie(sollL, istL));
   } // test05
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebDrehRumALJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebDrehRumALJut
