// Datei UebEntferneDoppelteRJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktion EntferneDoppelteR in
der Klasse UebEntferneDoppelteR
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse

public class UebEntferneDoppelteRJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebEntferneDoppelteRJut.class);
   } // suite
   // ---------------------------------------------------------------------
   static private boolean KommtVorR(int n, int[] r) {
      // Liefert true, wenn n in r vorkommt, sonst false.
      // Hilfsmethode fuer MengenGleichR

      for (int m: r) {
         if (n == m) return true;
      }
      return false;
   } // KommtVorR
   // ---------------------------------------------------------------------
   static public boolean MengenGleichR(int[] r1, int[] r2) {
      // Verlaesst sich darauf, dass r1 und r2 Mengen darstellen (d.h.
      // keine Doppelgaenger enthalten).
      // Liefert true, wenn r1 und r2 gleiche Mengen darstellen, und
      // sonst false.

      if (r1.length != r2.length) return false;

      for (int n1: r1) {
         if (!KommtVorR(n1, r2)) return false;
      }
      return true;
   } // MengenGleichR
   // ---------------------------------------------------------------------
   public void test01() {
      int[] r1   = {1, 2, 1, 3, 4, 5, 3};
      int[] soll = {1, 2, 3, 4, 5};
      int[] ist  = UebEntferneDoppelteR.EntferneDoppelteR(r1);
      assertTrue(MengenGleichR(soll, ist));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      int[] r1   = {1, 2, 3};
      int[] soll = {1, 2, 3};
      int[] ist  = UebEntferneDoppelteR.EntferneDoppelteR(r1);
      assertTrue(MengenGleichR(soll, ist));
   } // test02
   // ---------------------------------------------------------------------
   public void test03() {
      int[] r1   = {1, 1, 1, 1, 1};
      int[] soll = {1};
      int[] ist  = UebEntferneDoppelteR.EntferneDoppelteR(r1);
      assertTrue(MengenGleichR(soll, ist));
   } // test03
   // ---------------------------------------------------------------------
   public void test04() {
      int[] r1   = {1, 2, 3, 3, 2, 1};
      int[] soll = {1, 2, 3};
      int[] ist  = UebEntferneDoppelteR.EntferneDoppelteR(r1);
      assertTrue(MengenGleichR(soll, ist));
   } // test04
   // ---------------------------------------------------------------------
   public void test05() {
      int[] r1   = {1, 1};
      int[] soll = {1};
      int[] ist  = UebEntferneDoppelteR.EntferneDoppelteR(r1);
      assertTrue(MengenGleichR(soll, ist));
   } // test05
   // ---------------------------------------------------------------------
   public void test06() {
      int[] r1   = {1};
      int[] soll = {1};
      int[] ist  = UebEntferneDoppelteR.EntferneDoppelteR(r1);
      assertTrue(MengenGleichR(soll, ist));
   } // test06
   // ---------------------------------------------------------------------
   public void test07() {
      int[] r1   = {};
      int[] soll = {};
      int[] ist  = UebEntferneDoppelteR.EntferneDoppelteR(r1);
      assertTrue(MengenGleichR(soll, ist));
   } // test07
   // ---------------------------------------------------------------------
   public void test08() {

   } // test08
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebEntferneDoppelteRJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebEntferneDoppelteRJut
