// Datei UebKopiereTiefRJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktion KopiereTiefR in
der Klasse UebKopiereTiefR
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse

public class UebKopiereTiefRJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebKopiereTiefRJut.class);
   } // suite
   // ---------------------------------------------------------------------
   static private boolean istTiefeKopie(StringBuilder[] orig,
                                        StringBuilder[] kopi)
   {
      // Liefert true, wenn kopi eine tiefe Kopie von orig ist, d.h.
      // wenn kopi Referenzen enthaelt, die auf Kopien der Komponenten
      // von orig zeigen (und nicht Refernezen, die auf die original-
      // Komponenten von orig zeigen).

      if (orig == kopi)                return false;
      if (orig.length != kopi.length)  return false;

      for (int i=0; i<orig.length; i++) {
         if ( orig[i] == kopi[i])      return false; // Kompos identisch

         // Achtung: Die equals-Methode der Klasse StringBuilder prueft auf
         // Identitaet, nicht auf Gleichheit. Um Gleichheit festzustellen
         // muss man StringBuilder-Objekte in String-Objekte umwandeln und
         // die mit der equals-Methode der Klasse String vergleichen:
         String strOrig = orig[i].toString();
         String strKopi = kopi[i].toString();
         if (!strOrig.equals(strKopi)) return false; // Kompos nicht gleich
      }
      // Jetzt sind alle Kompos orig[i] und kopi[i] zwar gleich, aber
      // nicht identisch (d.h. kopi ist eine tiefe Kopie von orig).
      return true;
   } // istTiefeKopie
   // ---------------------------------------------------------------------
   StringBuilder a1 = new StringBuilder("Hallo");
   StringBuilder a2 = new StringBuilder("Wie geht's?");
   StringBuilder a3 = new StringBuilder("Gut!");
   StringBuilder a4 = new StringBuilder();
   StringBuilder a5 = new StringBuilder();
   StringBuilder a6 = new StringBuilder();
   // ---------------------------------------------------------------------
   public void test01() {
      StringBuilder[] orig = {a1, a2, a3, a4};
      StringBuilder[] kopi = UebKopiereTiefR.KopiereTiefR(orig);
      assertTrue(istTiefeKopie(orig, kopi));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      StringBuilder[] orig = {a4, a5, a6}; // 3 gleiche Komponenten
      StringBuilder[] kopi = UebKopiereTiefR.KopiereTiefR(orig);
      assertTrue(istTiefeKopie(orig, kopi));
   } // test02
   // ---------------------------------------------------------------------
   public void test03() {
      StringBuilder[] orig = {a4, a4, a4}; // 3 identische Komponenten
      StringBuilder[] kopi = UebKopiereTiefR.KopiereTiefR(orig);
      assertTrue(istTiefeKopie(orig, kopi));
   } // test03
   // ---------------------------------------------------------------------
   public void test04() {
      StringBuilder[] orig = {};
      StringBuilder[] kopi = UebKopiereTiefR.KopiereTiefR(orig);
      assertTrue(istTiefeKopie(orig, kopi));
   } // test04
   // ---------------------------------------------------------------------
   public void test05() {

   } // test05
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebKopiereTiefRJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebKopiereTiefRJut
