// Datei UebLongNachBerZahlStringJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktion LongNachBerZahlString in
der Klasse UebLongNachBerZahlString
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse

public class UebLongNachBerZahlStringJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebLongNachBerZahlStringJut.class);
   } // suite
   // ---------------------------------------------------------------------
   // Die Basiszahlen muessen vom Typ short sein:
   short B02 =  2; // Die kleinste zulaessige Basis
   short B05 =  5;
   short B10 = 10;
   short B16 = 16;
   short B36 = 36; // Die groesste zulaessige Basis
   short B01 =  1; // Eine zu kleine Basis
   short B37 = 37; // Eine zu grosse Basis

   // Zwei ziemlich grosse Testzahlen:
   long  n1  = 123456789012345678L;
   long  n2  = 210987654321098765L;
   // ---------------------------------------------------------------------
   // Die 0 in verschiedenen Zahlensystemen:
   public void test00() {
      assertEquals("0", UebLongNachBerZahlString.LongNachBerZahlString(  0, B02));
      assertEquals("0", UebLongNachBerZahlString.LongNachBerZahlString(  0, B05));
      assertEquals("0", UebLongNachBerZahlString.LongNachBerZahlString(  0, B10));
      assertEquals("0", UebLongNachBerZahlString.LongNachBerZahlString(  0, B16));
      assertEquals("0", UebLongNachBerZahlString.LongNachBerZahlString(  0, B36));
   } // test00
   // ---------------------------------------------------------------------
   // Alle einstelligen Zahlen und die erste zweistellige Zahl
   // in verschiedenen Zahlensystemen:
   public void test01() {
      assertEquals( "1", UebLongNachBerZahlString.LongNachBerZahlString( 1, B02));
      assertEquals("10", UebLongNachBerZahlString.LongNachBerZahlString( 2, B02));

      assertEquals( "1", UebLongNachBerZahlString.LongNachBerZahlString( 1, B05));
      assertEquals( "2", UebLongNachBerZahlString.LongNachBerZahlString( 2, B05));
      assertEquals( "3", UebLongNachBerZahlString.LongNachBerZahlString( 3, B05));
      assertEquals( "4", UebLongNachBerZahlString.LongNachBerZahlString( 4, B05));
      assertEquals("10", UebLongNachBerZahlString.LongNachBerZahlString( 5, B05));

      assertEquals( "1", UebLongNachBerZahlString.LongNachBerZahlString( 1, B10));
      assertEquals( "2", UebLongNachBerZahlString.LongNachBerZahlString( 2, B10));
      assertEquals( "3", UebLongNachBerZahlString.LongNachBerZahlString( 3, B10));
      assertEquals( "4", UebLongNachBerZahlString.LongNachBerZahlString( 4, B10));
      assertEquals( "5", UebLongNachBerZahlString.LongNachBerZahlString( 5, B10));
      assertEquals( "6", UebLongNachBerZahlString.LongNachBerZahlString( 6, B10));
      assertEquals( "7", UebLongNachBerZahlString.LongNachBerZahlString( 7, B10));
      assertEquals( "8", UebLongNachBerZahlString.LongNachBerZahlString( 8, B10));
      assertEquals( "9", UebLongNachBerZahlString.LongNachBerZahlString( 9, B10));
      assertEquals("10", UebLongNachBerZahlString.LongNachBerZahlString(10, B10));

      assertEquals( "1", UebLongNachBerZahlString.LongNachBerZahlString( 1, B16));
      assertEquals( "2", UebLongNachBerZahlString.LongNachBerZahlString( 2, B16));
      assertEquals( "3", UebLongNachBerZahlString.LongNachBerZahlString( 3, B16));
      assertEquals( "4", UebLongNachBerZahlString.LongNachBerZahlString( 4, B16));
      assertEquals( "5", UebLongNachBerZahlString.LongNachBerZahlString( 5, B16));
      assertEquals( "6", UebLongNachBerZahlString.LongNachBerZahlString( 6, B16));
      assertEquals( "7", UebLongNachBerZahlString.LongNachBerZahlString( 7, B16));
      assertEquals( "8", UebLongNachBerZahlString.LongNachBerZahlString( 8, B16));
      assertEquals( "9", UebLongNachBerZahlString.LongNachBerZahlString( 9, B16));
      assertEquals( "A", UebLongNachBerZahlString.LongNachBerZahlString(10, B16));
      assertEquals( "B", UebLongNachBerZahlString.LongNachBerZahlString(11, B16));
      assertEquals( "C", UebLongNachBerZahlString.LongNachBerZahlString(12, B16));
      assertEquals( "D", UebLongNachBerZahlString.LongNachBerZahlString(13, B16));
      assertEquals( "E", UebLongNachBerZahlString.LongNachBerZahlString(14, B16));
      assertEquals( "F", UebLongNachBerZahlString.LongNachBerZahlString(15, B16));
      assertEquals("10", UebLongNachBerZahlString.LongNachBerZahlString(16, B16));

      assertEquals( "1", UebLongNachBerZahlString.LongNachBerZahlString( 1, B36));
      assertEquals( "2", UebLongNachBerZahlString.LongNachBerZahlString( 2, B36));
      assertEquals( "3", UebLongNachBerZahlString.LongNachBerZahlString( 3, B36));
      assertEquals( "4", UebLongNachBerZahlString.LongNachBerZahlString( 4, B36));
      assertEquals( "5", UebLongNachBerZahlString.LongNachBerZahlString( 5, B36));
      assertEquals( "6", UebLongNachBerZahlString.LongNachBerZahlString( 6, B36));
      assertEquals( "7", UebLongNachBerZahlString.LongNachBerZahlString( 7, B36));
      assertEquals( "8", UebLongNachBerZahlString.LongNachBerZahlString( 8, B36));
      assertEquals( "9", UebLongNachBerZahlString.LongNachBerZahlString( 9, B36));
      assertEquals( "A", UebLongNachBerZahlString.LongNachBerZahlString(10, B36));
      assertEquals( "B", UebLongNachBerZahlString.LongNachBerZahlString(11, B36));
      assertEquals( "C", UebLongNachBerZahlString.LongNachBerZahlString(12, B36));
      assertEquals( "D", UebLongNachBerZahlString.LongNachBerZahlString(13, B36));
      assertEquals( "E", UebLongNachBerZahlString.LongNachBerZahlString(14, B36));
      assertEquals( "F", UebLongNachBerZahlString.LongNachBerZahlString(15, B36));
      assertEquals( "G", UebLongNachBerZahlString.LongNachBerZahlString(16, B36));
      assertEquals( "H", UebLongNachBerZahlString.LongNachBerZahlString(17, B36));
      assertEquals( "I", UebLongNachBerZahlString.LongNachBerZahlString(18, B36));
      assertEquals( "J", UebLongNachBerZahlString.LongNachBerZahlString(19, B36));
      assertEquals( "K", UebLongNachBerZahlString.LongNachBerZahlString(20, B36));
      assertEquals( "L", UebLongNachBerZahlString.LongNachBerZahlString(21, B36));
      assertEquals( "M", UebLongNachBerZahlString.LongNachBerZahlString(22, B36));
      assertEquals( "N", UebLongNachBerZahlString.LongNachBerZahlString(23, B36));
      assertEquals( "O", UebLongNachBerZahlString.LongNachBerZahlString(24, B36));
      assertEquals( "P", UebLongNachBerZahlString.LongNachBerZahlString(25, B36));
      assertEquals( "Q", UebLongNachBerZahlString.LongNachBerZahlString(26, B36));
      assertEquals( "R", UebLongNachBerZahlString.LongNachBerZahlString(27, B36));
      assertEquals( "S", UebLongNachBerZahlString.LongNachBerZahlString(28, B36));
      assertEquals( "T", UebLongNachBerZahlString.LongNachBerZahlString(29, B36));
      assertEquals( "U", UebLongNachBerZahlString.LongNachBerZahlString(30, B36));
      assertEquals( "V", UebLongNachBerZahlString.LongNachBerZahlString(31, B36));
      assertEquals( "W", UebLongNachBerZahlString.LongNachBerZahlString(32, B36));
      assertEquals( "X", UebLongNachBerZahlString.LongNachBerZahlString(33, B36));
      assertEquals( "Y", UebLongNachBerZahlString.LongNachBerZahlString(34, B36));
      assertEquals( "Z", UebLongNachBerZahlString.LongNachBerZahlString(35, B36));
      assertEquals("10", UebLongNachBerZahlString.LongNachBerZahlString(36, B36));
   } // test01
   // ---------------------------------------------------------------------
   // Zahlen im 2-er-System:
   public void test02() {
      String s1 = "110110110100110110100101110100110001100001111001101001110";
      String s2 = "1011101101100101000010011101011011110011010101000000001101";

      assertEquals("101010", UebLongNachBerZahlString.LongNachBerZahlString(42, B02));
      assertEquals("110101", UebLongNachBerZahlString.LongNachBerZahlString(53, B02));
      assertEquals(s1      , UebLongNachBerZahlString.LongNachBerZahlString(n1, B02));
      assertEquals(s2      , UebLongNachBerZahlString.LongNachBerZahlString(n2, B02));
   } // test02
   // ---------------------------------------------------------------------
   // Zahlen im 5-er-System:
   public void test05() {
      assertEquals( "100",  UebLongNachBerZahlString.LongNachBerZahlString( 25, B05));
      assertEquals( "200",  UebLongNachBerZahlString.LongNachBerZahlString( 50, B05));
      assertEquals( "300",  UebLongNachBerZahlString.LongNachBerZahlString( 75, B05));
      assertEquals( "400",  UebLongNachBerZahlString.LongNachBerZahlString(100, B05));
      assertEquals("1000",  UebLongNachBerZahlString.LongNachBerZahlString(125, B05));

      assertEquals("11111", UebLongNachBerZahlString.LongNachBerZahlString( 781, B05));
      assertEquals("22222", UebLongNachBerZahlString.LongNachBerZahlString(1562, B05));
      assertEquals("33333", UebLongNachBerZahlString.LongNachBerZahlString(2343, B05));
      assertEquals("44444", UebLongNachBerZahlString.LongNachBerZahlString(3124, B05));

      String s1 = "2013423212012344130030203";
      String s2 = "3232214033212022200130030";

      assertEquals(s1, UebLongNachBerZahlString.LongNachBerZahlString(n1, B05));
      assertEquals(s2, UebLongNachBerZahlString.LongNachBerZahlString(n2, B05));
   } // test05
   // ---------------------------------------------------------------------
   // Zahlen im 10-er-System:
   public void test10() {
      String s1 = "123456789012345678";
      String s2 = "210987654321098765";

      assertEquals(s1, UebLongNachBerZahlString.LongNachBerZahlString(n1, B10));
      assertEquals(s2, UebLongNachBerZahlString.LongNachBerZahlString(n2, B10));
   } // test10
   // ---------------------------------------------------------------------
   // Zahlen im 16-er-System:
   public void test16() {
      String s1 = "1B69B4BA630F34E";
      String s2 = "2ED94275BCD500D";

      assertEquals(s1, UebLongNachBerZahlString.LongNachBerZahlString(n1, B16));
      assertEquals(s2, UebLongNachBerZahlString.LongNachBerZahlString(n2, B16));
   } // test16
   // ---------------------------------------------------------------------
   // Zahlen im 36-er-System:
   public void test36() {
      String s1 = "XRLS1WQ49JI";
      String s2 = "1LPGVQB6ZA4T";

      assertEquals(s1, UebLongNachBerZahlString.LongNachBerZahlString(n1, B36));
      assertEquals(s2, UebLongNachBerZahlString.LongNachBerZahlString(n2, B36));
   } // test36
   // ---------------------------------------------------------------------
   public void testFalscheParams() {
      assertEquals("", UebLongNachBerZahlString.LongNachBerZahlString( 12, B01));
      assertEquals("", UebLongNachBerZahlString.LongNachBerZahlString( 12, B37));
      assertEquals("", UebLongNachBerZahlString.LongNachBerZahlString(-12, B02));
      assertEquals("", UebLongNachBerZahlString.LongNachBerZahlString(-12, B05));
      assertEquals("", UebLongNachBerZahlString.LongNachBerZahlString(-12, B10));
      assertEquals("", UebLongNachBerZahlString.LongNachBerZahlString(-12, B16));
      assertEquals("", UebLongNachBerZahlString.LongNachBerZahlString(-12, B36));
   } // testFalscheParams
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebLongNachBerZahlStringJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebLongNachBerZahlStringJut
