// Datei UebMengenEnthaeltALJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktion MengenEnthaeltAL in
der Klasse UebMengenEnthaeltAL
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse
import java.util.ArrayList;
import java.util.Arrays;

public class UebMengenEnthaeltALJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebMengenEnthaeltALJut.class);
   } // suite
   // ---------------------------------------------------------------------
   // n11 und n21 sind gleich (n11.equals(n12) ist true)
   // aber nicht identisch    (n11==n12        ist false)
   // Fuer die anderen Variablen entsprechend.
   Integer n11 = new Integer(1), n21 = new Integer(1);
   Integer n12 = new Integer(2), n22 = new Integer(2);
   Integer n13 = new Integer(3), n23 = new Integer(3);
   Integer n14 = new Integer(4), n24 = new Integer(4);
   Integer n15 = new Integer(5), n25 = new Integer(5);
   Integer n16 = new Integer(6), n26 = new Integer(6);
   // ---------------------------------------------------------------------
   public void test01() {
      Integer[] r1 = {n11, n12, n13, n14, n15};
      Integer[] r2 = {n23, n21, n25, n24};
      ArrayList<Integer> al1 = new ArrayList<Integer>(Arrays.asList(r1));
      ArrayList<Integer> al2 = new ArrayList<Integer>(Arrays.asList(r2));
      assertTrue(UebMengenEnthaeltAL.MengenEnthaeltAL(al1, al2));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      Integer[] r1 = {n11};
      Integer[] r2 = {n21};
      ArrayList<Integer> al1 = new ArrayList<Integer>(Arrays.asList(r1));
      ArrayList<Integer> al2 = new ArrayList<Integer>(Arrays.asList(r2));
      assertTrue(UebMengenEnthaeltAL.MengenEnthaeltAL(al1, al2));
   } // test02
   // ---------------------------------------------------------------------
   public void test03() {
      Integer[] r1 = {};
      Integer[] r2 = {};
      ArrayList<Integer> al1 = new ArrayList<Integer>(Arrays.asList(r1));
      ArrayList<Integer> al2 = new ArrayList<Integer>(Arrays.asList(r2));
      assertTrue(UebMengenEnthaeltAL.MengenEnthaeltAL(al1, al2));
   } // test03
   // ---------------------------------------------------------------------
   public void test04() {
      Integer[] r1 = {n11, n12, n13, n14};
      Integer[] r2 = {n23, n21, n15, n24, n22};
      ArrayList<Integer> al1 = new ArrayList<Integer>(Arrays.asList(r1));
      ArrayList<Integer> al2 = new ArrayList<Integer>(Arrays.asList(r2));
      assertFalse(UebMengenEnthaeltAL.MengenEnthaeltAL(al1, al2));
   } // test04
   // ---------------------------------------------------------------------
   public void test05() {
      Integer[] r1 = {n11, n12, n13, n14, n25};
      Integer[] r2 = {n23, n21, n15, n26};
      ArrayList<Integer> al1 = new ArrayList<Integer>(Arrays.asList(r1));
      ArrayList<Integer> al2 = new ArrayList<Integer>(Arrays.asList(r2));
      assertFalse(UebMengenEnthaeltAL.MengenEnthaeltAL(al1, al2));
   } // test05
   // ---------------------------------------------------------------------
   public void test06() {
      Integer[] r1 = {n11, n12, n13, n14, n16};
      Integer[] r2 = {n23, n21, n25, n24, n22};
      ArrayList<Integer> al1 = new ArrayList<Integer>(Arrays.asList(r1));
      ArrayList<Integer> al2 = new ArrayList<Integer>(Arrays.asList(r2));
      assertFalse(UebMengenEnthaeltAL.MengenEnthaeltAL(al1, al2));
   } // test06
   // ---------------------------------------------------------------------
   public void test07() {
      Integer[] r1 = {n11};
      Integer[] r2 = {n23};
      ArrayList<Integer> al1 = new ArrayList<Integer>(Arrays.asList(r1));
      ArrayList<Integer> al2 = new ArrayList<Integer>(Arrays.asList(r2));
      assertFalse(UebMengenEnthaeltAL.MengenEnthaeltAL(al1, al2));
   } // test07
   // ---------------------------------------------------------------------
   public void test08() {

   } // test08
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebMengenEnthaeltALJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebMengenEnthaeltALJut
