// Datei UebQuersummeBJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktion QuersummeB in der Klasse UebQuersummeB
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse

public class UebQuersummeBJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebQuersummeBJut.class);
   } // suite
   // ---------------------------------------------------------------------
   short b01  =  1;              // Eine zu kleine Basis
   short b02  =  2;              // Die kleinste zulaessige Basis
   short b05  =  5;
   short b10  = 10;
   short b16  = 16;
   short bmax = Short.MAX_VALUE; // Die groesste zulaessige Basis
   // ---------------------------------------------------------------------
   public void test01() {
      assertEquals( 1, UebQuersummeB.QuersummeB(16, b02 ));
      assertEquals( 4, UebQuersummeB.QuersummeB(16, b05 ));
      assertEquals( 7, UebQuersummeB.QuersummeB(16, b10 ));
      assertEquals( 1, UebQuersummeB.QuersummeB(16, b16 ));
      assertEquals(16, UebQuersummeB.QuersummeB(16, bmax));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      assertEquals( 1, UebQuersummeB.QuersummeB(-b02 , b02 ));
      assertEquals( 1, UebQuersummeB.QuersummeB(-b05 , b05 ));
      assertEquals( 1, UebQuersummeB.QuersummeB(-b10 , b10 ));
      assertEquals( 1, UebQuersummeB.QuersummeB(-b16 , b16 ));
      assertEquals( 1, UebQuersummeB.QuersummeB(-bmax, bmax));
   } // test02
   // ---------------------------------------------------------------------
   public void test03() {
      int qs1   = 2*bmax-2;
      int zahl1 = bmax*bmax-1;

      assertEquals(  8, UebQuersummeB.QuersummeB(255 ,  b02 ));
      assertEquals(  6, UebQuersummeB.QuersummeB( 86 ,  b05 ));
      assertEquals(  6, UebQuersummeB.QuersummeB(123 ,  b10 ));
      assertEquals( 20, UebQuersummeB.QuersummeB(170 ,  b16 ));
      assertEquals(qs1, UebQuersummeB.QuersummeB(zahl1, bmax));
   } // test03
   // ---------------------------------------------------------------------
   public void test04() {
      assertEquals(   16, UebQuersummeB.QuersummeB(123456789, b02 ));
      assertEquals(   21, UebQuersummeB.QuersummeB(123456789, b05 ));
      assertEquals(   45, UebQuersummeB.QuersummeB(123456789, b10 ));
      assertEquals(   54, UebQuersummeB.QuersummeB(123456789, b16 ));
      assertEquals(27267, UebQuersummeB.QuersummeB(123456789, bmax));
   } // test04
   // ---------------------------------------------------------------------
   public void test05() {
      assertEquals(-1, UebQuersummeB.QuersummeB(123456789, b01 ));
   } // test05
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebQuersummeBJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebQuersummeBJut
