// Datei UebString5erZahlNachLongJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktion String5erZahlNachLong in der Klasse UebString5erZahlNachLong
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse

public class UebString5erZahlNachLongJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebString5erZahlNachLongJut.class);
   } // suite
   // ---------------------------------------------------------------------
   public void test01() {
      String s0 = "0";  // Eine 5-er-Zahl
      String s1 = "1";
      String s2 = "2";
      String s3 = "3";
      String s4 = "4";
      String s5 = "10"; // Eine 5-er-Zahl (dezimale Darstellung: 5)

      long   n0 = 0;
      long   n1 = 1;
      long   n2 = 2;
      long   n3 = 3;
      long   n4 = 4;
      long   n5 = 5;

      assertEquals(n0, UebString5erZahlNachLong.String5erZahlNachLong(s0));
      assertEquals(n1, UebString5erZahlNachLong.String5erZahlNachLong(s1));
      assertEquals(n2, UebString5erZahlNachLong.String5erZahlNachLong(s2));
      assertEquals(n3, UebString5erZahlNachLong.String5erZahlNachLong(s3));
      assertEquals(n4, UebString5erZahlNachLong.String5erZahlNachLong(s4));
      assertEquals(n5, UebString5erZahlNachLong.String5erZahlNachLong(s5));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      // Strings, die keine korrekte 5-er-Zahl darstellen:
      String s1 = "";
      String s2 = "+12";
      String s3 = "12-";
      String s4 = "12345"; // Falsche Ziffer 5
      String s5 = "12X3";  // Falsches Zeichen X

      long   n  = Long.MIN_VALUE;

      assertEquals(n, UebString5erZahlNachLong.String5erZahlNachLong(s1));
      assertEquals(n, UebString5erZahlNachLong.String5erZahlNachLong(s2));
      assertEquals(n, UebString5erZahlNachLong.String5erZahlNachLong(s3));
      assertEquals(n, UebString5erZahlNachLong.String5erZahlNachLong(s4));
      assertEquals(n, UebString5erZahlNachLong.String5erZahlNachLong(s5));
   } // test02
   // ---------------------------------------------------------------------
   public void test03() {
      // Zwei ziemlich grosse (aber nicht zu grosse) 5-er-Zahlen:
      String s1 = "1234012340123401234012340";
      String s2 = "4321043210432104321043210";

      long   n1 = 92536020217875970L;
      long   n2 = 279516019833377930L;

      assertEquals(n1, UebString5erZahlNachLong.String5erZahlNachLong(s1));
      assertEquals(n2, UebString5erZahlNachLong.String5erZahlNachLong(s2));
   } // test03
   // ---------------------------------------------------------------------
   public void test04() {
      // Zwei zu grosse 5-er-Zahlen (bei der Umwandlung tritt mindestens
      // einmal ein Ueberlauf auf):
      String s1 = "123401234012340123401234012340";
      String s2 = "432104321043210432104321043210";

      long   n1 = -5972841998490418636L;
      long   n2 =  6490590514957108228L;

      assertEquals(n1, UebString5erZahlNachLong.String5erZahlNachLong(s1));
      assertEquals(n2, UebString5erZahlNachLong.String5erZahlNachLong(s2));
   } // test04
   // ---------------------------------------------------------------------
   public void test05() {

   } // test05
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebString5erZahlNachLongJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebString5erZahlNachLongJut
