// Datei UebStringBerZahlNachLongJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktion StringBerZahlNachLong in der Klasse UebStringBerZahlNachLong
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse

public class UebStringBerZahlNachLongJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebStringBerZahlNachLongJut.class);
   } // suite
   // ---------------------------------------------------------------------
   // Die Basiszahlen muessen vom Typ short sein:
   short B01 =  1; // Eine zu kleine Basis
   short B02 =  2; // Die kleinste zulaessige Basis
   short B05 =  5;
   short B10 = 10;
   short B16 = 16;
   short B36 = 36; // Die groesste zulaessige Basis
   short B37 = 37; // Eine zu grosse Basis

   // ---------------------------------------------------------------------
   public void test01() {
      assertEquals( 1, UebStringBerZahlNachLong.StringBerZahlNachLong( "1", B02));
      assertEquals( 2, UebStringBerZahlNachLong.StringBerZahlNachLong("10", B02));

      assertEquals( 1, UebStringBerZahlNachLong.StringBerZahlNachLong( "1", B05));
      assertEquals( 2, UebStringBerZahlNachLong.StringBerZahlNachLong( "2", B05));
      assertEquals( 3, UebStringBerZahlNachLong.StringBerZahlNachLong( "3", B05));
      assertEquals( 4, UebStringBerZahlNachLong.StringBerZahlNachLong( "4", B05));
      assertEquals( 5, UebStringBerZahlNachLong.StringBerZahlNachLong("10", B05));

      assertEquals( 1, UebStringBerZahlNachLong.StringBerZahlNachLong( "1", B10));
      assertEquals( 2, UebStringBerZahlNachLong.StringBerZahlNachLong( "2", B10));
      assertEquals( 3, UebStringBerZahlNachLong.StringBerZahlNachLong( "3", B10));
      assertEquals( 4, UebStringBerZahlNachLong.StringBerZahlNachLong( "4", B10));
      assertEquals( 5, UebStringBerZahlNachLong.StringBerZahlNachLong( "5", B10));
      assertEquals( 6, UebStringBerZahlNachLong.StringBerZahlNachLong( "6", B10));
      assertEquals( 7, UebStringBerZahlNachLong.StringBerZahlNachLong( "7", B10));
      assertEquals( 8, UebStringBerZahlNachLong.StringBerZahlNachLong( "8", B10));
      assertEquals( 9, UebStringBerZahlNachLong.StringBerZahlNachLong( "9", B10));
      assertEquals(10, UebStringBerZahlNachLong.StringBerZahlNachLong("10", B10));

      assertEquals( 1, UebStringBerZahlNachLong.StringBerZahlNachLong( "1", B16));
      assertEquals( 2, UebStringBerZahlNachLong.StringBerZahlNachLong( "2", B16));
      assertEquals( 3, UebStringBerZahlNachLong.StringBerZahlNachLong( "3", B16));
      assertEquals( 4, UebStringBerZahlNachLong.StringBerZahlNachLong( "4", B16));
      assertEquals( 5, UebStringBerZahlNachLong.StringBerZahlNachLong( "5", B16));
      assertEquals( 6, UebStringBerZahlNachLong.StringBerZahlNachLong( "6", B16));
      assertEquals( 7, UebStringBerZahlNachLong.StringBerZahlNachLong( "7", B16));
      assertEquals( 8, UebStringBerZahlNachLong.StringBerZahlNachLong( "8", B16));
      assertEquals( 9, UebStringBerZahlNachLong.StringBerZahlNachLong( "9", B16));
      assertEquals(10, UebStringBerZahlNachLong.StringBerZahlNachLong( "A", B16));
      assertEquals(11, UebStringBerZahlNachLong.StringBerZahlNachLong( "B", B16));
      assertEquals(12, UebStringBerZahlNachLong.StringBerZahlNachLong( "C", B16));
      assertEquals(13, UebStringBerZahlNachLong.StringBerZahlNachLong( "D", B16));
      assertEquals(14, UebStringBerZahlNachLong.StringBerZahlNachLong( "E", B16));
      assertEquals(15, UebStringBerZahlNachLong.StringBerZahlNachLong( "F", B16));
      assertEquals(16, UebStringBerZahlNachLong.StringBerZahlNachLong("10", B16));

      assertEquals( 1, UebStringBerZahlNachLong.StringBerZahlNachLong( "1", B36));
      assertEquals( 2, UebStringBerZahlNachLong.StringBerZahlNachLong( "2", B36));
      assertEquals( 3, UebStringBerZahlNachLong.StringBerZahlNachLong( "3", B36));
      assertEquals( 4, UebStringBerZahlNachLong.StringBerZahlNachLong( "4", B36));
      assertEquals( 5, UebStringBerZahlNachLong.StringBerZahlNachLong( "5", B36));
      assertEquals( 6, UebStringBerZahlNachLong.StringBerZahlNachLong( "6", B36));
      assertEquals( 7, UebStringBerZahlNachLong.StringBerZahlNachLong( "7", B36));
      assertEquals( 8, UebStringBerZahlNachLong.StringBerZahlNachLong( "8", B36));
      assertEquals( 9, UebStringBerZahlNachLong.StringBerZahlNachLong( "9", B36));
      assertEquals(10, UebStringBerZahlNachLong.StringBerZahlNachLong( "A", B36));
      assertEquals(11, UebStringBerZahlNachLong.StringBerZahlNachLong( "B", B36));
      assertEquals(12, UebStringBerZahlNachLong.StringBerZahlNachLong( "C", B36));
      assertEquals(13, UebStringBerZahlNachLong.StringBerZahlNachLong( "D", B36));
      assertEquals(14, UebStringBerZahlNachLong.StringBerZahlNachLong( "E", B36));
      assertEquals(15, UebStringBerZahlNachLong.StringBerZahlNachLong( "F", B36));
      assertEquals(16, UebStringBerZahlNachLong.StringBerZahlNachLong( "G", B36));
      assertEquals(17, UebStringBerZahlNachLong.StringBerZahlNachLong( "H", B36));
      assertEquals(18, UebStringBerZahlNachLong.StringBerZahlNachLong( "I", B36));
      assertEquals(19, UebStringBerZahlNachLong.StringBerZahlNachLong( "J", B36));
      assertEquals(20, UebStringBerZahlNachLong.StringBerZahlNachLong( "K", B36));
      assertEquals(21, UebStringBerZahlNachLong.StringBerZahlNachLong( "L", B36));
      assertEquals(22, UebStringBerZahlNachLong.StringBerZahlNachLong( "M", B36));
      assertEquals(23, UebStringBerZahlNachLong.StringBerZahlNachLong( "N", B36));
      assertEquals(24, UebStringBerZahlNachLong.StringBerZahlNachLong( "O", B36));
      assertEquals(25, UebStringBerZahlNachLong.StringBerZahlNachLong( "P", B36));
      assertEquals(26, UebStringBerZahlNachLong.StringBerZahlNachLong( "Q", B36));
      assertEquals(27, UebStringBerZahlNachLong.StringBerZahlNachLong( "R", B36));
      assertEquals(28, UebStringBerZahlNachLong.StringBerZahlNachLong( "S", B36));
      assertEquals(29, UebStringBerZahlNachLong.StringBerZahlNachLong( "T", B36));
      assertEquals(30, UebStringBerZahlNachLong.StringBerZahlNachLong( "U", B36));
      assertEquals(31, UebStringBerZahlNachLong.StringBerZahlNachLong( "V", B36));
      assertEquals(32, UebStringBerZahlNachLong.StringBerZahlNachLong( "W", B36));
      assertEquals(33, UebStringBerZahlNachLong.StringBerZahlNachLong( "X", B36));
      assertEquals(34, UebStringBerZahlNachLong.StringBerZahlNachLong( "Y", B36));
      assertEquals(35, UebStringBerZahlNachLong.StringBerZahlNachLong( "Z", B36));
      assertEquals(36, UebStringBerZahlNachLong.StringBerZahlNachLong("10", B36));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      String s1 = "101010101010101010101010101010101010101010101010101010101010";
      String s2 = "000011100011100011100011100011100011100011100011100011100011";

      long   n1 = 768614336404564650L;
      long   n2 =  64051194700380387L;

      assertEquals(n1, UebStringBerZahlNachLong.StringBerZahlNachLong(s1, B02));
      assertEquals(n2, UebStringBerZahlNachLong.StringBerZahlNachLong(s2, B02));
   } // test02
   // ---------------------------------------------------------------------
   public void test05() {
      String s1 = "1234012340123401234012340";
      String s2 = "4321043210432104321043210";

      long   n1 =  92536020217875970L;
      long   n2 = 279516019833377930L;

      assertEquals(n1, UebStringBerZahlNachLong.StringBerZahlNachLong(s1, B05));
      assertEquals(n2, UebStringBerZahlNachLong.StringBerZahlNachLong(s2, B05));
   } // test05
   // ---------------------------------------------------------------------
   public void test10() {
      String s1 = "123456789012345678";
      String s2 = "876543210987654321";

      long   n1 = 123456789012345678L;
      long   n2 = 876543210987654321L;

      assertEquals(n1, UebStringBerZahlNachLong.StringBerZahlNachLong(s1, B10));
      assertEquals(n2, UebStringBerZahlNachLong.StringBerZahlNachLong(s2, B10));
   } // test10
   // ---------------------------------------------------------------------
   public void test16() {
      String s1 = "123456789ABCDEF0";
      String s2 = "0FEDCBA987654321";

      long   n1 = 1311768467463790320L;
      long   n2 = 1147797409030816545L;

      assertEquals(n1, UebStringBerZahlNachLong.StringBerZahlNachLong(s1, B16));
      assertEquals(n2, UebStringBerZahlNachLong.StringBerZahlNachLong(s2, B16));
   } // test16
   // ---------------------------------------------------------------------
   public void test36() {
      String s1 = "1289ABYZ";
      String s2 = "ZAHLEN123";

      long   n1 =    83217056795L;
      long   n2 = 99560788080411L;

      assertEquals(n1, UebStringBerZahlNachLong.StringBerZahlNachLong(s1, B36));
      assertEquals(n2, UebStringBerZahlNachLong.StringBerZahlNachLong(s2, B36));
   } // test36
   // ---------------------------------------------------------------------
   public void testFalscheParams() {
      long n = Long.MIN_VALUE;

      assertEquals(n, UebStringBerZahlNachLong.StringBerZahlNachLong("101", B01));
      assertEquals(n, UebStringBerZahlNachLong.StringBerZahlNachLong("101", B37));
      assertEquals(n, UebStringBerZahlNachLong.StringBerZahlNachLong("",    B10));

      assertEquals(n, UebStringBerZahlNachLong.StringBerZahlNachLong("012", B02));
      assertEquals(n, UebStringBerZahlNachLong.StringBerZahlNachLong("345", B05));
      assertEquals(n, UebStringBerZahlNachLong.StringBerZahlNachLong("89A", B10));
      assertEquals(n, UebStringBerZahlNachLong.StringBerZahlNachLong("EFG", B16));
      assertEquals(n, UebStringBerZahlNachLong.StringBerZahlNachLong("YZ[", B36));

   } // testFalscheParams
   // ---------------------------------------------------------------------
   public void testZuGrosseZahlen() {
      String s02 = "1000100010001000100010001000100010001000100010001000100010001000";
      String s05 = "123401234012340123401234012340123401";
      String s10 = "12345678901234567890";
      String s16 = "8FFFFFFFFFFFFFFF";
      String s36 = "ZYXWVUTSRQPONM";

      long   n02 = -8608480567731124088L;
      long   n05 = -3577957516169557305L;
      long   n10 = -6101065172474983726L;
      long   n16 = -8070450532247928833L;
      long   n36 = -6836576133089530094L;

      assertEquals(n02, UebStringBerZahlNachLong.StringBerZahlNachLong(s02, B02));
      assertEquals(n05, UebStringBerZahlNachLong.StringBerZahlNachLong(s05, B05));
      assertEquals(n10, UebStringBerZahlNachLong.StringBerZahlNachLong(s10, B10));
      assertEquals(n16, UebStringBerZahlNachLong.StringBerZahlNachLong(s16, B16));
      assertEquals(n36, UebStringBerZahlNachLong.StringBerZahlNachLong(s36, B36));

   } // testZuGrosseZahlen
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebStringBerZahlNachLongJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebStringBerZahlNachLongJut
